```mermaid
graph TD
    Usecase1["Usecase 1: enable/disable MFA for a school"];
	U1A["tVM calls either<br>update-mfa-admin-group enable school1<br>or<br>update-mfa-admin-group disable school1"];
	U1File(["File /etc/dataport-schuposh-mfa-admin-enabled-schools"]);
	U1B("update-mfa-admin-group collects all enabled OUs from<br>/etc/dataport-schuposh-mfa-admin-enabled-schools<br>and merges the group members of &quot;admins-$OU&quot;<br>of all enabled schools into the group &quot;mfa-admins&quot;");
	LDAP(["LDAP<br>Group &quot;mfa-admins&quot;"]);
	U1ListenerModule["Listener module<br>dataport-schuposh-twofactor-admin-module<br>gets triggered by changes of &quot;admins-$OU&quot; groups"];
	Portal["Shows portal entry &quot;2fa-administration&quot; depending<br>on users group membership in &quot;mfa-admins&quot;"];
	UMC["Shows UMC module &quot;2FA admin&quot; depending<br>on users group membership in &quot;mfa-admins&quot;"];

	Usecase1 --> U1A;
	U1A -->|"command adds/removes specified school to/from file"| U1File;
	U1A -->|"command calls implicitly/internally<br>update-mfa-admin-group update<br>to keep group &quot;mfa-admins&quot; up-to-date."| U1B;
	U1B -->|"reads schools from"| U1File;
	U1B -->|"updates members of &quot;mfa-admins&quot; in"| LDAP;
	LDAP2["LDAP change"] --> U1ListenerModule;
	U1ListenerModule -->|"module's postrun() calls<br>update-mfa-admin-groups update<br>to keep group &quot;mfa-admins&quot; up-to-date."| U1B;

	UMC -->|"UMC policy cn=2fa-admin-umc is<br>assigned to group &quot;mfa-admins&quot;"| LDAP;
	Portal -->|"reads group &quot;mfa-admins&quot; from"| LDAP;
```
