#!/bin/bash
source ./credentials.sh

eval "$(ucr shell)"
# This needs demoschool and a second Test School called ts
if [ -z "$(univention-ldapsearch -LLL ou=DEMOSCHOOL)" ]; then
	/usr/share/ucs-school-import/scripts/create_ou --displayName "Demo School" DEMOSCHOOL
fi

if [ -z "$(univention-ldapsearch -LLL ou=ts)" ]; then
	/usr/share/ucs-school-import/scripts/create_ou --displayName "2FA Testschule" ts
fi
#udm groups/group create --position="cn=groups,$ldap_base" --set name=2fa-admins
#udm groups/group create --position="cn=groups,$ldap_base" --set name=2fa-user
# creating users with udm for ucs@school is tricky and not advised
# However, this seems to work
# https://help.univention.com/t/how-a-ucs-school-user-should-look-like/15630

udm users/user create --position=cn=lehrer,cn=users,ou=ts,$ldap_base \
  --set username=$TESTUSER1 \
  --append groups="cn=lehrer-ts,cn=groups,ou=ts,$ldap_base" \
  --append groups="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base" \
  --set primaryGroup="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base" \
  --set description="Meier Test User" \
  --set displayName="meier" \
  --set lastname=meier \
  --set password=$TESTUSER1PASS \
  --append school=ts \
  --append ucsschoolRole=teacher:school:ts \
  --append-option=ucsschoolTeacher

udm users/user create --position=cn=lehrer,cn=users,ou=DEMOSCHOOL,$ldap_base \
  --set username=$TESTUSER2 \
  --append groups="cn=lehrer-DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --append groups="cn=Domain Users DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --set primaryGroup="cn=Domain Users DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --set description="Schmidt Test User" \
  --set displayName="schmidt" \
  --set lastname=schmidt \
  --set password=$TESTUSER2PASS \
  --append school=demoschool \
  --append ucsschoolRole=teacher:school:demoschool \
  --append-option=ucsschoolTeacher

udm users/user create --position=cn=lehrer,cn=users,ou=ts,$ldap_base \
  --set username=$TESTUSER3 \
  --append groups="cn=lehrer-ts,cn=groups,ou=ts,$ldap_base" \
  --append groups="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base" \
  --set primaryGroup="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base" \
  --set description="Mueller Test User" \
  --set displayName="mueller" \
  --set lastname=meier \
  --set password=$TESTUSER3PASS \
  --append school=ts \
  --append ucsschoolRole=teacher:school:ts \
  --append-option=ucsschoolTeacher

udm users/user create --position=cn=mitarbeiter,cn=users,ou=DEMOSCHOOL,$ldap_base \
  --set username=$TESTEMPLOYEE \
  --append groups="cn=admins-DEMOSCHOOL,cn=ouadmins,cn=groups,$ldap_base" \
  --append groups="cn=mitarbeiter-DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --append groups="cn=Domain Users DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --set primaryGroup="cn=Domain Users DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --set description="Sek Test User" \
  --set displayName="Sek User" \
  --set lastname=Sekretariat \
  --set password=$TESTEMPLOYEEPASS \
  --append school=DEMOSCHOOL \
  --append ucsschoolRole=staff:school:DEMOSCHOOL \
  --append-option=ucsschoolStaff

udm users/user create --position=cn=mitarbeiter,cn=users,ou=ts,$ldap_base \
  --set username=$TESTEMPLOYEE2 \
  --append groups="cn=admins-DEMOSCHOOL,cn=ouadmins,cn=groups,$ldap_base" \
  --append groups="cn=mitarbeiter-DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --append groups="cn=Domain Users DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --append groups="cn=admins-ts,cn=ouadmins,cn=groups,$ldap_base" \
  --append groups="cn=mitarbeiter-ts,cn=groups,ou=ts,$ldap_base" \
  --append groups="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base"\
  --set primaryGroup="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base" \
  --set description="Sek Test User 2" \
  --set displayName="Sek User 2" \
  --set lastname=Sekretariat2 \
  --set password=$TESTEMPLOYEE2PASS \
  --append school=ts \
  --append school=DEMOSCHOOL \
  --append ucsschoolRole=staff:school:ts \
  --append ucsschoolRole=staff:school:DEMOSCHOOL \
  --append-option=ucsschoolStaff

udm users/user create --position=cn=mitarbeiter,cn=users,ou=ts,$ldap_base \
  --set username=$TESTEMPLOYEE3 \
  --append groups="cn=mitarbeiter-ts,cn=groups,ou=ts,$ldap_base" \
  --append groups="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base" \
  --set primaryGroup="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base" \
  --set description="Sek Test User 3" \
  --set displayName="Sek User 3" \
  --set lastname="Sekretariat 3" \
  --set password=$TESTEMPLOYEE3PASS \
  --append school=ts \
  --append ucsschoolRole=staff:school:ts \
  --append-option=ucsschoolStaff

udm users/user create --position=cn=users,$ldap_base \
  --set username=$TESTDOMAINADMIN \
  --append groups="cn=Domain Admins,cn=groups,"$ldap_base \
  --append groups="cn=Domain Users,cn=groups,"$ldap_base \
  --set primaryGroup="cn=Domain Admins,cn=groups,"$ldap_base \
  --set description="Dirk Domain Admin" \
  --set displayName="dadmin" \
  --set lastname=dadmin \
  --set password=$TESTDOMAINADMINPASS \

udm users/user create --position=cn=schueler,cn=users,ou=ts,$ldap_base \
  --set username=$TESTSTUDENT1 \
  --append groups="cn=schueler-ts,cn=groups,ou=ts,$ldap_base" \
  --append groups="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base" \
  --set primaryGroup="cn=Domain Users ts,cn=groups,ou=ts,$ldap_base" \
  --set description="Student Test User" \
  --set displayName="student" \
  --set lastname=student \
  --set password=$TESTSTUDENT1PASS \
  --append school=ts \
  --append ucsschoolRole=student:school:ts \
  --append-option=ucsschoolStudent

udm users/user create --position=cn=schueler,cn=users,ou=DEMOSCHOOL,$ldap_base \
  --set username=$TESTSTUDENT2 \
  --append groups="cn=schueler-DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --append groups="cn=Domain Users DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --set primaryGroup="cn=Domain Users DEMOSCHOOL,cn=groups,ou=DEMOSCHOOL,$ldap_base" \
  --set description="Student Test User" \
  --set displayName="student" \
  --set lastname=student \
  --set password=$TESTSTUDENT2PASS \
  --append school=DEMOSCHOOL \
  --append ucsschoolRole=student:school:DEMOSCHOOL \
  --append-option=ucsschoolStudent
