import os
import sys
import time
from shutil import copyfile

from dirsync import sync
from watchdog.events import FileModifiedEvent
from watchdog.observers.polling import PollingObserver as Observer


# Usage: Mount Virtualbox share from your host/dev system
# example fstab entry:
# /virtualbox_share	/media/sf_virtualbox_share 	vboxsf	defaults,uid=1000,gid=1000,rw     0 	0
# run python hot_reload.py umc

# TODO: REST Mode, trigger restart from testcase to avoid glitches and copious debugger restarts?
# watchdog keeps track if a restart is needed, testcase triggers it at the right moment? Nah, gotta start
# the debugger first...

class CopyRestartEvent(FileModifiedEvent):
    def dispatch(self, event):
        if isinstance(event, FileModifiedEvent):
            # ignore generated assets since a pkill disturbes testruns
            if not event.src_path.endswith('.jpg') and not event.src_path.endswith('.pdf') and not event.src_path.endswith('workspace.xml'):
                print("reload because %s was modified" % event.src_path)
                # TODO if between UCS versions
                # sync("./umc/python/twofactor_admin", "/usr/lib/python3/dist-packages/univention/management/console/modules/twofactor_admin", 'sync')
                sync("./umc/python/twofactor_admin", "/usr/lib/python2.7/dist-packages/univention/management/console/modules/twofactor_admin", 'sync')
                sync("./umc/js", "/usr/share/univention-management-console-frontend/js/umc/modules/", 'sync')
                copyfile("./umc/twofactor_admin.xml", "/usr/share/univention-management-console/modules/twofactor_admin.xml")
                # ret = os.system("univention-management-console-server restart")
                os.system("pkill -f console-module")
            else:
                print("ignoring %s" % event.src_path)

if __name__ == "__main__":
    path = sys.argv[1] if len(sys.argv) > 1 else '.'
    event_handler = CopyRestartEvent(path)
    observer = Observer()
    observer.schedule(event_handler, path, recursive=True)
    observer.start()

    try:
        while True:
            time.sleep(1)
    except KeyboardInterrupt:
        observer.stop()
    observer.join()
