# Testcases

## Prerequisities

* you have to execute the scripts under `../../../fixtures`
* `source ../../../fixtures/credentials.sh` to have the user credentials in your environment

* python packages:
	* [hotpie](https://pypi.org/project/hotpie/)
	* requests
	* [Selenium WebDriver](https://splinter.readthedocs.io)


## Single tests
(in alphabetical order)
* `test_acls.py` - tests the implemented ACLs
* `test_autosearch.py` - checks the autosearch functionality in the GUI
* `test_gui.py` - frontend test using selenium webdriver
* `test_privacyidea_jsonrpc.py` - Tests the access to the privacyIDEA API directly
* `test_umc_endpoints.py` - tests the UMC-Module directly by accessing the modules with JSONRPC
* `token_helper.py` - helper function to create test OTP tokens

## Execution
The tests are written as [Python unittests](https://docs.python.org/3/library/unittest.html#).
They can be run with the standard python lib like this: `python -m unittest`

Alternatively, it's possible to run them with pytest: `python -m pytest`
