"""

    This test accesses the privacyIDEA API directly. The purpose is to develop our helper classes fast
    and to keep it clear of univention dependencies to enable partners to run a test / review a problem
    without having to install ucs. Also this helps to distinguish whose realm an issue lies in.

"""

import unittest
from os import environ

import requests

import token_helper
# from univention.management.console.modules.twofactor_admin.twofactor_admin import disable_or_delete_all_tokens_for_user, rollout_qr_token, rollover_hardware_token
from .twofactor_admin import disable_or_delete_all_tokens_for_user, rollout_qr_token, rollover_hardware_token
# from envs_vars import *


class TestSchoolToken(unittest.TestCase):
    auth_token = ""

    @classmethod
    def setUpClass(self):
        self.auth_token = token_helper.auth()
        disable_or_delete_all_tokens_for_user(environ['TESTUSER1'], environ['TESTPRIVACYIDEA_URL'], self.auth_token)

    def testOTP(self):
        token_helper.delete_test_token(environ['TESTPRIVACYIDEA_URL'], self.auth_token)
        result = rollout_qr_token(environ['TESTPRIVACYIDEA_URL'], self.auth_token, environ['TESTUSER1'])
        self.assertIn("data:image/png;base64", result['image'])
        print(result['image'])

    # Hardware OTP Token
    def testHOPT(self):
        token_helper.delete_test_token(environ['TESTPRIVACYIDEA_URL'], self.auth_token)
        token_helper.create_test_token(environ['TESTPRIVACYIDEA_URL'], self.auth_token)
        # create and assign token
        result = rollover_hardware_token(environ['TESTPRIVACYIDEA_URL'], self.auth_token, environ['TESTUSER1'], token_helper.serial,
                                         token_helper.get_current_otp())
        self.assertTrue(result['result']['status'])

    def test_token(self):
        r = requests.get(environ['TESTPRIVACYIDEA_URL'] + "/token", headers={'Authorization': self.auth_token})
        result = r.json()['result']
        self.assertTrue(result['status'])


if __name__ == '__main__':
    unittest.main()
